// point mass class
// -Kyoung Shin Park (2009 Spring)
//////////////////////////////////////////////////////////////////////
#ifndef __POINT_MASS_H__
#define __POINT_MASS_H__

#include "vector3.h"

namespace oglclass {

class pointmass
{
public:
    pointmass(const vector3& pos=vector3::Zero, float m=1.0);
    void clearForces(void);
    void applyForce(vector3& force);
    void update(float dt);
    void freezePosition(void);
    void unfreezePosition(void);

    inline float mass(void) { return mass_; }
    inline vector3& position(void) { return position_; }
    inline vector3& velocity(void) { return velocity_; }
    inline vector3& acceleration(void) { return acceleration_; }
    inline bool frozen(void) { return frozen_; }
    inline float drag(void) { return drag_; }

    void setMass(const float m);
    void setPosition(const vector3& pos);
    void setVelocity(const vector3& vel);
    void setAcceleration(const vector3& acc);
    void setDrag(const float d=0);

private:
    float mass_;
    vector3 position_;
    vector3 velocity_;
    vector3 acceleration_;
    bool frozen_;
    float drag_;
};

} // namespace

#endif
